Loading...
Searching...
No Matches
SharedLibraryClassApi.h File Reference
`#include "robottestingframework_dll_config.h"`
`#include <cstring>`
Include dependency graph for SharedLibraryClassApi.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes

struct | shlibpp::SharedLibraryClassApi
| Collection of hooks for creating/destroying a plugin. More...

## Namespaces

namespace | shlibpp

## Macros

#define | SHLIBPP_SHARED_CLASS_FN extern "C" SHLIBPP_EXPORT
#define | SHLIBPP_DEFINE_SHARED_SUBCLASS(factoryname, classname, basename)
| Macro to create a bunch of functions with undecorated names that can be found within a plugin library to handle creation/deletion of that plugin.
#define | SHLIBPP_DEFAULT_FACTORY_NAME "shlibpp_default_factory"
#define | SHLIBPP_DEFINE_DEFAULT_SHARED_CLASS(classname)
#define | SHLIBPP_DEFINE_SHARED_CLASS(factoryname, classname)

## Macro Definition Documentation

## SHLIBPP_DEFAULT_FACTORY_NAME

#define SHLIBPP_DEFAULT_FACTORY_NAME "shlibpp_default_factory"

Definition at line 150 of file SharedLibraryClassApi.h.

## SHLIBPP_DEFINE_DEFAULT_SHARED_CLASS

#define SHLIBPP_DEFINE_DEFAULT_SHARED_CLASS | ( |  | classname | ) |

Value:
SHLIBPP_DEFINE_SHARED_SUBCLASS(shlibpp_default_factory, classname, classname)
SHLIBPP_DEFINE_SHARED_SUBCLASS
#define SHLIBPP_DEFINE_SHARED_SUBCLASS(factoryname, classname, basename)
Macro to create a bunch of functions with undecorated names that can be found within a plugin library...
Definition SharedLibraryClassApi.h:84

Definition at line 151 of file SharedLibraryClassApi.h.

## SHLIBPP_DEFINE_SHARED_CLASS

#define SHLIBPP_DEFINE_SHARED_CLASS | ( |  | factoryname,
|  |  | classname )

Value:
SHLIBPP_DEFINE_SHARED_SUBCLASS(factoryname, classname, classname)

Definition at line 152 of file SharedLibraryClassApi.h.

## SHLIBPP_DEFINE_SHARED_SUBCLASS

#define SHLIBPP_DEFINE_SHARED_SUBCLASS | ( |  | factoryname,
|  |  | classname,
|  |  | basename )

Macro to create a bunch of functions with undecorated names that can be found within a plugin library to handle creation/deletion of that plugin.

Use with care.

Parameters

  factoryname | the name of the "hook" function to make. A collection of other helper functions with names composed of the factoryname with _create/_destroy/... appended.
  classname | the class that the hook will be able to instantiate.
  basename | the superclass that the user of the plugin should be working with.

Definition at line 84 of file SharedLibraryClassApi.h.

## SHLIBPP_SHARED_CLASS_FN

#define SHLIBPP_SHARED_CLASS_FN extern "C" SHLIBPP_EXPORT

Definition at line 66 of file SharedLibraryClassApi.h.